"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _getExamples = _interopRequireDefault(require("./getExamples"));

it('getExamples() should return require with examples-loader if component has example files', function () {
  var file = 'file.md';
  var examplesFile = __filename;
  var result = (0, _getExamples["default"])(file, examplesFile);

  if (!result || Array.isArray(result)) {
    return;
  }

  expect(result.require.includes(examplesFile)).toBe(true);
  expect(result.require.includes('componentName=')).toBe(false);
});
it('getExamples() should return require with examples-loader is component has examples', function () {
  var file = 'file.md';
  var examplesFile = 'foo';
  var fallbackName = 'Baz';
  var defaultExample = 'foo.js';
  var result = (0, _getExamples["default"])(file, examplesFile, fallbackName, defaultExample);

  if (!result || Array.isArray(result)) {
    return;
  }

  expect(result.require.includes(__filename)).toBe(false);
  expect(result.require.includes(fallbackName)).toBe(true);
  expect(result.require.includes(defaultExample)).toBe(true);
  expect(result.require.includes('displayName=')).toBe(true);
});
it('getExamples() should return null if component has no example file', function () {
  var file = 'file.md';
  var examplesFile = 'foo';
  var result = (0, _getExamples["default"])(file, examplesFile);
  expect(result).toEqual(null);
});